/*	TProjectView.h
 *
 *		This is the view which displays the table of contents of a project.
 *	This incorporates in-line editing of the resource ID and the resource
 *  name of each of the resources in a project
 */

/*  YAAF Constructor - Rapid application development for YAAF
 *  Copyright (C) 1998 William Edward Woody
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 *  02111-1307, USA.
 *  
 *  To contact the author, either e-mail me at woody@pandawave.com, 
 *	or write to
 *  
 *          William Edward Woody
 *          In Phase Consulting
 *          1545 Ard Eevin Avenue
 *          Glendale, CA 91202
 *
 *	Or visit us on the web at http://www.pandawave.com
 */

#ifndef PandaWave_TPROJECTVIEW
#define PandaWave_TPROJECTVIEW

#include <XMessages.h>
#include <XView.h>

/************************************************************************/
/*																		*/
/*	View Structure														*/
/*																		*/
/************************************************************************/

struct TProjectView : public XGView {
	public:
						TProjectView(XGOwner *owner, XGArgStream &stream);
		virtual			~TProjectView();
		
		enum {
			kClassID = 'prVW'
		};
		
		/*
		 *	Event overrides
		 */
		
		void			DoDrawView(Rect);
		void			DoSizeView(void);
		bool			DoMouseDown(Point,short);
	
		/*
		 *	Globals
		 */
		
		DECLAREDISPATCH
		long			DoChangeSelect(long arg, void *parg);
		long			DoDocChanged(long arg, void *parg);
		long			DoMenuCommand(long arg, void *parg);
		long			DoGetMenuStatus(long arg, void *parg);
	
	private:
		long			fSelLine;
		short			fSelType;
		long			fOpenFlags;
		
		void			DrawResourceLine(XGDraw &, short x, short y, short resType, long index);
		void			DrawResourceHeader(XGDraw &, short x, short y, short resType);
		void			RecalcScroll();
		
		long			GetDispLines();
		bool			GetSelectItem(long select, short *type, long *index);
		void			OpenSelect();
		void			GetSelectInfo();
		void			DeleteItem();
};


#endif // PandaWave_TPROJECTVIEW
